//
//  B6Model.swift
//  BASE64
//
//  Created by narita on 2019/02/01.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class B6Model: NSObject
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // 変換関数を書く ( base64へ変換している )
    @objc func convert(_ string: NSString) -> NSString
    {
        let theData = string.data(using: String.Encoding.utf8.rawValue)

        if let theResult = theData?.base64EncodedString()
        {
            return theResult as NSString
        }
        
        return ""
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)

    @objc  class func keyPathsForValuesAffectingConvertedString() -> Set<String>
    {
        return [ "planeString" ]
    }
    
    @objc var planeString: NSString = ""
    
    @objc var convertedString: NSString
    {
        get
        {
            return self.convert(self.planeString)
        }
    }
    
    // MARK: - Utility methods
}
