//
//  MTEViewController.swift
//  miniTextEdit
//
//  Created by narita on 2019/02/02.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class MTEViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        self.view.window?.initialFirstResponder = self.textView
    }

    // MARK: - action methods
    
    @IBAction func performServicesMenu(_ sender: Any?)
    {        
        if let theSender: NSControl = sender as? NSControl
        {
            let theMenuItem: NSMenuItem = NSApp.servicesMenu!.items[theSender.tag]
            
            let theServiceName = theMenuItem.value(forKeyPath: "representedObject.defaultTitle") as! String
            
            let thePB = NSPasteboard.withUniqueName()
            
            textView?.writeSelection(to: thePB,
                                     types: [
                                                NSPasteboard.PasteboardType(rawValue: "public.rtf"),
                                                NSPasteboard.PasteboardType(rawValue: "public.utf8-plain-text"),
                                                NSPasteboard.PasteboardType(rawValue: "com.apple.flat-rtfd")
                ])
            
            let theString = textView!.string as NSString
            let theSubString = theString.substring( with: textView!.selectedRange() )
            
            thePB.setString(theSubString ,
                            forType: NSPasteboard.PasteboardType(rawValue: "public.utf8-plain-text"))
            
            
            if NSPerformService(theServiceName, thePB)
            {
                textView?.readSelection(from: thePB)
            }
        }
    }

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    // MARK: - accessor methods (in pairs)
    
    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
        }
    }
    
    @IBOutlet var textView: NSTextView? = nil

    // MARK: - Utility methods
}

